unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Forms, Graphics;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormPaint(Sender: TObject);
  private
    procedure MyEllipse(x1, y1, x2, y2: Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormPaint(Sender: TObject);
begin
  MyEllipse(10, 10, ClientWidth - 10, ClientHeight - 10);
end;

procedure TForm1.MyEllipse(x1, y1, x2, y2: Integer);
type
  TListPoint = record
    x, y: Integer;
    Next: Pointer;
    Angle: Double;
  end;
  PListPoint = ^TListPoint;

var
  x, y: Integer;
  mx, my, rx, ry: Double;
  FirstListPoint: PListPoint;

  function NeedPoint(p1, p2: PListPoint): Boolean;
  begin
    if not Assigned(p1) then
      Exit(False);
    if not Assigned(p2) then
      if Assigned(FirstListPoint) then
        p2 := FirstListPoint
      else
        Exit(False);

    Result:=(Abs(p1^.x - p2^.x) > 1) or (Abs(p1^.y - p2^.y) > 1);
  end;
  function NewPoint(Prev, Next: PListPoint): PListPoint;
  var
    Dummy: PListPoint;
  begin
    New(Result);
    Result^.Next:=Next;
    if Assigned(Prev) then
      Prev^.Next:=Result;
    if not Assigned(Next) then
      Result^.Angle:=Pi * 4
    else
      Result^.Angle:=Next^.Angle;
    if not Assigned(Prev) then
      Result^.Angle:=Result^.Angle / 2
    else
      Result^.Angle:=(Result^.Angle + Prev^.Angle) / 2;

    Result^.x:=Round(mx + sin(Result^.Angle) * rx);
    Result^.y:=Round(my + cos(Result^.Angle) * ry);

    Dummy:=nil;
    if NeedPoint(Prev, Result) then begin
      Dummy:=NewPoint(Prev, Result);
    end;
    if NeedPoint(Result, Next) then begin
      Result:=NewPoint(Result, Next);
    end;
    if Assigned(Dummy) then Result:=Dummy;
  end;
  procedure DrawPoints;
  var
    p: PListPoint;
  begin
    p:=FirstListPoint;
    while Assigned(p) do begin
      Canvas.Pixels[p^.x, p^.y]:=clRed;  //hier könntest du jedes beliebiges Ziel z.B. ein Array nutzen
      p:=p^.Next;
    end;
  end;
  procedure ClearPoints;
  var
    p, pNext: PListPoint;
  begin
    p:=FirstListPoint;
    while Assigned(p) do begin
      pNext:=p^.Next;
      Dispose(p);
      p:=pNext;
    end;
  end;

begin
  if x2 < x1 then begin
    x:=x2;
    x2:=x1;
    x1:=x;
  end;
  if y2 < y1 then begin
    y:=y2;
    y2:=y1;
    y1:=y;
  end;
  rx:=(x2 - x1) / 2;
  ry:=(y2 - y1) / 2;
  mx:=(x2 + x1) / 2;
  my:=(y2 + y1) / 2;

  if (rx > 0) and (ry > 0) then begin
    FirstListPoint:=nil;
    FirstListPoint:=NewPoint(nil, nil);
    NewPoint(FirstListPoint, nil);
    DrawPoints;
    ClearPoints;
  end;
end;

end.

